import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;

import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;

public class W {
    public static void main(final String[] args) throws XMLStreamException {
        final String test = "<trix xmlns=\"http://www.w3.org/2004/03/trix/trix-1/\">\n"
                + "      <typedLiteral datatype=\"http://www.w3.org/2001/XMLSchema#string\">172.21.23.16</typedLiteral>\n"
                + "</trix>\n";

        final InputStream is = new ByteArrayInputStream( test.getBytes( StandardCharsets.UTF_8 ) );

        System.setProperty( XMLInputFactory.class.getName(), "com.sun.xml.internal.stream.XMLInputFactoryImpl" );
        //System.setProperty( XMLInputFactory.class.getName(), "com.ctc.wstx.stax.WstxInputFactory" );
        XMLInputFactory fac = XMLInputFactory.newInstance();
        System.out.println( "Factory class " + fac.getClass().getName() );
        System.out.println( "Namespace aware: " + fac.getProperty( XMLInputFactory.IS_NAMESPACE_AWARE ) );

        final XMLInputFactory staxInputFactory = XMLInputFactory.newInstance();
        final XMLStreamReader staxReader = staxInputFactory.createXMLStreamReader( is );

        System.out.println( "stream reader class " + staxReader.getClass().getName() );
        System.out.println( "Namespace aware: " + staxReader.getProperty( XMLInputFactory.IS_NAMESPACE_AWARE ) );

        // trix tag
        staxReader.nextTag();
        System.out.println( staxReader.getLocalName() );

        // typedLiteral tag
        staxReader.nextTag();
        System.out.println( staxReader.getLocalName() );

        System.out.println( "tag namespace: " + staxReader.getName().getNamespaceURI() );

        final String attributeLocalName = staxReader.getAttributeLocalName( 0 );
        System.out.println( "LocalName: " + attributeLocalName );

        final String namespaceURI = staxReader.getAttributeNamespace( 0 );
        System.out.println( "NS: [" + namespaceURI + "]" );

        final String namespacePfx = staxReader.getAttributePrefix( 0 );
        System.out.println( "PFX: [" + namespacePfx + "]" );

    }
}
